MODULE BIOX_P;
(*$S-,$T-,$Q+  mini
    1992-2016 Ari.Tao  * 09.03.92 ~ 02.01.98 + 07.02.13 ~ 07.05.16      .

       Utility fr Cookies, xBRAs & VBLs
*)
IMPORT AEI,AEB, GT;
FROM   Aux  IMPORT AD,LC,LI,IG,CD,BL,BS;
FROM   BIOX IMPORT WMAX,HMAX, HANDLE, CTL, Syield, KBShiftS, Peek,Poke,
        CON, iMOFF,iMREL,iYTOP,iYBOT, IkbdWS, KeyTblSetA, IsGrf, OwnIO,
        xBRA,xSet, InqVec,InqExc,GetExc,GetCookie,SetCookie,DelCookie,
        QueueVBL,LeaveVBL, vTOS,dTOS, SuperExec, Pause,Wait;
FROM   GT   IMPORT wS,wC, Ln,Sp, Home,ClrE, CurB,Cur0, Inv1,Inv0;
FROM SYSTEM IMPORT ADR, BYTE, NULL;

TYPE  SX_Ptr = POINTER TO ARRAY [0..7FFEH] OF CHAR;

PROCEDURE Knot; BEGIN IF modal THEN CurB; Pause; Cur0 END; Ln END Knot;

PROCEDURE wDec (z: ARRAY OF BYTE; l: IG); VAR a: AD; p: HANDLE;
 BEGIN IF (SIZE(z) <3) THEN a := ADR (z); GT.wDecW (a^, l);
                       ELSE p := ADR (z); GT.wDecL (p^, l) END; END wDec;
PROCEDURE wHex (z: ARRAY OF BYTE; l: IG); VAR a: AD; p: HANDLE;
 BEGIN IF (SIZE(z) <3) THEN a := ADR (z); GT.wHexW (a^, l);
                       ELSE p := ADR (z); GT.wHexL (p^, l) END; END wHex;
(*
PROCEDURE ShowScanCs;
 CONST CONTERM = 484H;
 VAR   c0,c1: BS; l: LI; ch: CHAR;
 BEGIN Ln; Ln; wS (" Read with ScanCode (leave by Esc): ");
   Peek (CONTERM, c0); c1 := c0; INCL (c1, 11);
   Poke (CONTERM, c1);
   REPEAT l := DevCi (CON); ch := CHAR (l);
      Ln; wS ("  "); GDB.RawCO (ch); wHex (l, 12);
      UNTIL (ch = 33c);
   Poke (CONTERM, c0);
   Clr; END ShowScanCs;
*)
PROCEDURE RawCN (VAR s: ARRAY OF BYTE);
   VAR S: SX_Ptr; i: IG;
 BEGIN S := ADR (s);
   FOR i := 0 TO 3 DO
    IF (S^[i] >= ' ') THEN wC (S^[i]);
    ELSIF modal (* OR ~raw *) THEN Inv1; wC ('.'); Inv0;
    ELSE  Sp  END; END (*i*); END RawCN;

PROCEDURE CookieTest;
   VAR i,l: LI; j,k,n: IG;
       pC: POINTER TO ARRAY CD OF RECORD Id,Val: LI END;
 BEGIN pC := GetExc (5A0H (*=COOKIEJAR*) DIV 4); Ln;
   IF (pC = NULL) THEN wS (" No CookieJar found! "); RETURN END;
   i := 0D; j := GetCookie (i, l) +1;     n := IG (l-1);
   IF (n < 0) OR (137 < n) THEN           n := 31;           (* vorlufig.*)
         wS (" Cookie-Jar corrupted! ");
   ELSIF (0 <= SetCookie ("BIOX", 1234H)) THEN INC (j);
   ELSE  wS (" Cookie-Jar filled up! ") END;        (* Inkl. Null-Cookie: *)
   wS (" Cookies: "); wDec (j, 1); wS (" of "); wDec (l, 1); Sp; Ln;
   wS ("  (Identity : Value [HEX, DEC, ASCII]) ");
   FOR k := 0 TO j DO   Ln; i := pC^[k].Id; l := pC^[k].Val;
       wS ("  "); RawCN (i); wS (" :");
       wHex (l, 10); wDec (l, 12); Sp; RawCN (l); END (*k*);
   END CookieTest;

PROCEDURE TestX;
 VAR   a: AD; i: IG; l: LI; vs: CD; dt: LC;
 BEGIN a := KeyTblSetA (NIL,NIL,NIL);
   Peek (426H (*ResValid*), a);       (* Sollte pi sein! *)
   Ln; Ln; wHex (a, 10); Ln;          (* Das ist es auch.*)
   Ln; vs := vTOS (); wHex (vs, 1);
   Ln; dt := dTOS (); wHex (dt, 1);
   Ln; Knot;
(*
   i := CursBRate (-1); wHex (i, 7);
        Cursor (SHOW);  wHex (i, 7);
   i := CursBRate (20); wHex (i, 7); Pause;
   i := CursBRate (60); wHex (i, 7); Pause;
        Cursor(STEADY); wHex (i, 7); Pause;
        Cursor (BLINK); wHex (i, 7); Pause;
   i := CursBRate (-2); wHex (i, 7); Pause;
        Cursor (HIDE);  wHex (i, 7); Pause;
*) END TestX;

VAR Count: IG;

PROCEDURE ShowSyxBRA;
   VAR k: CD; end_os: LC;
 BEGIN Peek (4FAH, end_os);
   Ln; wS (" xBra-list of system's variables (break by CTRL): ");
   Ln; wS ("   Adr  xBra      <Adr>     OldVec  ENTRY     NewPrc ");
   Ln; FOR k := 1 TO 53 DO wC ('-') END;  Count := 0;
   FOR k:= 8 TO CD(end_os) (* 52402 *) BY 2 DO ShowXBRAchain (AD(k), FALSE);
       IF (CTL IN KBShiftS ()) THEN RETURN END; END (*k*);
   Ln; wHex (end_os, 6); wS (" end.");
   END ShowSyxBRA;

PROCEDURE ShowXBRAchain ((*Start-*)Adr: AD; Last(*isToBeIncluded*): BL);
 CONST SP6 = "      ";
 VAR   new, conti: BL; MaxC: IG; x: xBRA; Entry, a: AD; n: IG;
 PROCEDURE Item;
  BEGIN IF (Count <  MaxC) THEN INC (Count); Ln ELSE Count := 0; Knot END;
    IF new THEN wHex (Adr, 6) ELSE wS (SP6) END; END Item;
 BEGIN new := TRUE;  MaxC := (HMAX DIV 16) -3; a := Adr;
  LOOP IF (a = Adr) & (a MOD 4 = 0) & (a < 2048) THEN n := IG (a DIV 4);
            conti := InqExc (n, Entry, x);
       ELSE conti := InqVec (a, Entry, x) END;
       IF ~ conti THEN EXIT ELSE Item; wS ("  "); new := FALSE END;
     WITH x DO          RawCN (Ident);
       wHex (Entry,11); wHex (OldVec, 11);
       wHex (ENTRY, 7); wHex (NewPrc, 11); Sp;
       IF  (AD (OldVec) = Entry) THEN RETURN END;              (* Zykel?! *)
       a := ADR(OldVec); END END (*x,L*);
  IF (0 < LI(Entry)) & Last THEN Item; wS (SP6);
       wHex (Entry, 11); END (*I*); END ShowXBRAchain;

VAR tFlag: BL; xT: xBRA; toggle: PROC;

PROCEDURE Toggle;                         (* nur orig. SM124, nicht M120! *)
   VAR Col0[0FF8240H]: IG;      (*$S-*)
 BEGIN IF tFlag THEN INC (Col0) ELSE DEC (Col0) END;
   tFlag := ~tFlag; END Toggle; (*$S=*)

PROCEDURE InstToggle;
 BEGIN tFlag := FALSE;  toggle := PROC (xSet ("TOGG", 0, Toggle, xT));
 (**)  xT.OldVec := toggle;                          (* Kleine Gemeinheit.*)
       IF (0# QueueVBL (toggle)) THEN END; END InstToggle;
PROCEDURE KillToggle;
 BEGIN IF (0# LeaveVBL (toggle)) THEN END;
    IF tFlag THEN  SuperExec (Toggle) END; END KillToggle;

PROCEDURE ShowVBList;
   VAR k,nQ: IG; aQ: AD;
 BEGIN Ln; wS (" Vectors of VBI-Queue: ");
   Peek (454H, nQ); Peek (456H, aQ);
   FOR k := 1 TO nQ DO ShowXBRAchain (aQ, TRUE); INC (aQ, 4) END;
   END ShowVBList;

PROCEDURE AllTests;
 BEGIN IF modal THEN Home END;
   Ln; CurB; ClrE;
   Ln; wS (" BIOX  2016 Heroe Glyfe ");
   Ln; wS ("  Cookies, xBRAs, VBL "); Knot;
(* IkbdWC (iYBOT); *)
(* IkbdWC (iMOFF); *)
(* ShowScanCs; Knot; *)
   CookieTest; Knot; DelCookie ("BIOX");
(* TestX; *)
   ShowSyxBRA; Knot;
(* InstToggle; *)
   ShowVBList; Knot;
(* KillToggle; *)
(* IkbdWC (iMREL); *)
(* IkbdWC (iYTOP); *)
   Ln; Cur0; wS (" EndOfBIOX ");
   Wait (40(*nVSyncs*)); (* > DoppelKlick-Zeit! Verhindert 'Durchklicken'.*)
   END AllTests;

PROCEDURE TeDeum;
   VAR m: AD; h: HANDLE;
 BEGIN m := 705CH;
   IF (AEB.Global.Version > 319H) THEN m := 7ABCH END;
   h := m; m := h^;
   AEB.WindSem (+AEB.UPDATE+AEB.MOCTRL);
   modal := OwnIO ();
   Syield;
   AEB.WindSem ((AEB.UPDATE+AEB.MOCTRL) * ORD(modal));
   AEB.GrafMouseDef (AD (AEB.MEX * ORD(modal)));
   AllTests;
   Syield;
   AEB.WindSem (+AEB.UPDATE);
   IF (AEB.Global.Version > 363H) THEN m := AEB.MenuLatch (AD(-1D)) END;
   m := AEB.MenuLatch (m);
   AEB.DeskRefresh;
   AEB.GrafMouseDef (AEB.MON);
   AEB.WindSem (0); END TeDeum;

  VAR modal,raw: BL; d: LC;
BEGIN (* raw := (0 > GetCookie ("MiNT", d)); *) modal := TRUE;
  IF  (AEI.APID < 0) OR
     ~(AEI.onRTX OR IsGrf()) THEN AllTests;     (* .TOS-Prg. on SingleAES.*)
  ELSE AEI.RunAccPrg ("  BIOX ", TeDeum) END;
  END  BIOX_P .
